> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/core/page-manipulation/reorder.md).

# Reordering pages in a PDF document on Server/Desktop

Learn how to reorder pages in a PDF document by reversing their order. Easily rearrange, sort, copy, delete, and merge PDF pages with code samples. The Apryse Server SDK streamlines secure document pr

{% hint style="info" %}
**Requirements**

Packages are required for production license. Trial keys have unlimited access to all features.

Demo showcases functionality using WebViewer UI.

<a href="https://apryse.com/capabilities#PageManipulation" class="button primary">Package: Page Manipulation</a><a href="https://showcase.apryse.com/create-thumbnail" class="button primary">Live demo</a>
{% endhint %}

To reorder pages in a PDF document by reversing the order of pages.

Given the copy and delete page operations described in other sections, it is easy to re-arrange and sort pages.

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
PDFDoc doc = new PDFDoc(filename);

int page_num = doc.GetPageCount();
for (int i=1; i<=page_num; ++i)
{
  PageIterator itr = doc.GetPageIterator(i);
  Page page = itr.Current();
  doc.PageRemove(itr);
  doc.PagePushFront(page);
}
```

{% endcode %}
{% endtab %}

{% tab title="C++" %}
{% code lineNumbers="true" %}

```cpp
PDFDoc doc(filename);

int page_num = doc.GetPageCount();
for (int i=1; i<=page_num; ++i)
{
  PageIterator itr = doc.GetPageIterator(i);
  Page page = itr.Current();
  doc.PageRemove(itr);
  doc.PagePushFront(page);
}
```

{% endcode %}
{% endtab %}

{% tab title="Go" %}
{% code lineNumbers="true" %}

```go
doc := NewPDFDoc(filename)

pageNum = doc.GetPageCount()
for i := 1; i < pageNum; i++ {
      itr := inDoc.GetPageIterator(i)
      page := itr.Current()
      doc.PageRemove(itr)
      doc.PagePushFront(page);
}
```

{% endcode %}
{% endtab %}

{% tab title="Java" %}
{% code lineNumbers="true" %}

```java
PDFDoc doc = new PDFDoc(filename);

int page_num = doc.getPageCount();
for (int i=1; i<=page_num; ++i)
{
  PageIterator itr = doc.getPageIterator(i);
  Page page = itr.current();
  doc.pageRemove(itr);
  doc.pagePushFront(page);
}
```

{% endcode %}
{% endtab %}

{% tab title="JavaScript" %}
{% code lineNumbers="true" %}

```js
async function main() {
  const doc = await PDFNet.PDFDoc.createFromURL(filename);

  const page_num = await doc.getPageCount();
  for (let i=1; i<=page_num; ++i)
  {
    const itr = await doc.getPageIterator(i);
    const page = await itr.current();
    doc.pageRemove(itr);
    doc.pagePushFront(page);
  }
}
PDFNet.runWithCleanup(main);
```

{% endcode %}
{% endtab %}

{% tab title="Kotlin" %}
{% code lineNumbers="true" %}

```kotlin
val doc = PDFDoc(filename)

val page_num = doc.getPageCount();
for (i in 1..page_num)
{
  val itr = doc.getPageIterator(i);
  val page = itr.current();
  doc.pageRemove(itr);
  doc.pagePushFront(page);
}
```

{% endcode %}
{% endtab %}

{% tab title="Obj-C" %}
{% code lineNumbers="true" %}

```objc
PTPDFDoc *doc = [[PTPDFDoc alloc] initWithFilepath: filename];

int page_num = [doc GetPageCount];
for (int i=1; i<=page_num; ++i)
{
  PTPageIterator *itr = [doc GetPageIterator: i];
  PTPage *page = [itr Current];
  [doc PageRemove: itr];
  [doc PagePushFront: page];
}
```

{% endcode %}
{% endtab %}

{% tab title="Swift" %}
{% code lineNumbers="true" %}

```swift
let doc: PTPDFDoc = PTPDFDoc(filepath: filename)

let page_num = doc.getPageCount()
for i in 1..page_num
{
  let itr: PTPageIterator = doc.getPageIterator(i)
  let page: PTPage = itr.current()
  doc.pageRemove(itr)
  doc.pagePushFront(page)
}
```

{% endcode %}
{% endtab %}

{% tab title="PHP" %}
{% code lineNumbers="true" %}

```php
$doc = new PDFDoc($filename);

$page_num = $doc->GetPageCount();
for ($i = 1; $i <= $page_num; ++$i)
{
  $itr = $doc->GetPageIterator(i);
  $page = $itr->Current();
  $doc->PageRemove(itr);
  $doc->PagePushFront(page);
}
```

{% endcode %}
{% endtab %}

{% tab title="Python" %}
{% code lineNumbers="true" %}

```python
doc = PDFDoc(filename)

page_num = doc.GetPageCount()
for i in range(1, page_num):
  itr = doc.GetPageIterator(i)
  page = itr.Current()
  doc.PageRemove(itr)
  doc.PagePushFront(page)
```

{% endcode %}
{% endtab %}

{% tab title="Ruby" %}
{% code lineNumbers="true" %}

```ruby
doc = PDFDoc.new(filename)

page_num = doc.GetPageCount()
for i in 1..page_num do
  itr = doc.GetPageIterator(i)
  page = itr.Current()
  doc.PageRemove(itr)
  doc.PagePushFront(page)
end
```

{% endcode %}
{% endtab %}

{% tab title="VB" %}
{% code lineNumbers="true" %}

```vb
Dim doc4 As PDFDoc = New PDFDoc(filename)

Dim page_num As Integer = doc.GetPageCount()
For i = 1 To page_num
  Dim itr As PageIterator = doc.GetPageIterator(i)
  Dim page As Page = itr.Current()
  doc.PageRemove(itr)
  doc.PagePushFront(page)
Next i
```

{% endcode %}
{% endtab %}
{% endtabs %}

[Merge, copy, delete, and rearrange PDF pages](/core/get-started/samples/pdfpagetest.md) Full code sample which illustrates how to copy pages from one document to another, how to delete, and rearrange pages and how to use ImportPages(). Code sample is available in C++, C#, Java, Python, Go, PHP, Ruby & VB.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.apryse.com/core/page-manipulation/reorder.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
